<?php

class Raffles5_Api_Raffles extends vB_Api_Extensions
{
	protected $product = 'raffles5';
	protected $version = '5.0.4';
	protected $developer = 'Snog';
	protected $title = 'Raffles Api';
	protected $minver = '5.0.0 Alpha 28';
	protected $maxver = '5.9.99';
	protected $infourl = 'http://snogssite.com/misc.php?do=producthelp&pid=raffles5';
	protected $checkurl = 'http://snogssite.com/misc.php?do=productcheck&pid=raffles5';
	protected $AutoInstall = 1;
	protected $extensionOrder = 10;

	public static function getRaffles()
	{
		$mytime = time();

		if(vB::getDatastore()->getOption('raffle_showold'))
		{
			$getraffle = vB::getDbAssertor()->assertQuery('raffles5:getRafflesShowOld');
		}else{
			$getraffle = vB::getDbAssertor()->assertQuery('raffles5:getRafflesNoOld',array('mytime' => $mytime));
		}

		$phrases = array("at", "on", "raffle_active", "raffle_drawn", "raffle_waiting");
		$vbphrase = vB_Api::instanceInternal('phrase')->fetch($phrases);
		$maxlength = vB::getDatastore()->getOption('raffle_preview_max');

		foreach ($getraffle AS $raffle)
		{
			if(strlen($raffle['description']) > $maxlength)
			{
				if(strpos($raffle['description'],"[list]") && strpos($raffle['description'],"[list]") < $maxlength)
				{
					$raffle['description'] = substr($raffle['description'], 0, $maxlength) . '...[/list]';
				}else{
					$raffle['description'] = substr($raffle['description'], 0, $maxlength) . '...<br /><br />';
				}
			}else{
				$raffle['description'] = substr($raffle['description'], 0, $maxlength) . '...<br /><br />';
			}

			if(empty($raffle['prizeimg'])) $raffle['prizeimg'] = 'core/packages/raffles5/images/default.gif';
			$picturesize = getimagesize($raffle['prizeimg']);

			if($picturesize[0] > $picturesize[1])
			{ 
				$percentage = (vB::getDatastore()->getOption('raffle_maxpicsize') / $picturesize[0]); 
			}else{ 
				$percentage = (vB::getDatastore()->getOption('raffle_maxpicsize') / $picturesize[1]); 
			} 

			$raffle['picture_width'] = round($picturesize[0] * $percentage); 
			$raffle['picture_height'] = round($picturesize[1] * $percentage); 

			if($picturesize[0] > $picturesize[1])
			{ 
				$percentage = (vB::getDatastore()->getOption('raffle_sidebar_maxpicture') / $picturesize[0]); 
			}else{ 
				$percentage = (vB::getDatastore()->getOption('raffle_sidebar_maxpicture') / $picturesize[1]); 
			} 

			$raffle['picture_widthsm'] = round($picturesize[0] * $percentage); 
			$raffle['picture_heightsm'] = round($picturesize[1] * $percentage); 

			if($raffle['stopdate'] <= $mytime && $raffle['winner'] == "")
			{
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_wait_color') . "'><b>" . $vbphrase['raffle_waiting'] . "</b></font>";
				$raffle['view'] = 0;
			}elseif($raffle['winner'] != ""){
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_drawn_color') . "'><b>" . $vbphrase['raffle_drawn'] . "</b></font>";
				$raffle['view'] = 0;
			}else{
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_active_color') . "'><b>" . $vbphrase['raffle_active'] . "</b></font>";
				$raffle['view'] = 1;
			}
			$raw_enddate = $raffle['enddate'];
			
			$raffle['enddate'] = vbdate(vB::getDatastore()->getOption('dateformat'), $raw_enddate);
			if(vB::getDatastore()->getOption('raffle_showtime')) $raffle['enddate'] .= ' ' . $vbphrase['at'] . ' ' . vbdate(vB::getDatastore()->getOption('timeformat'), $raw_enddate);

			$raffle['oneless'] = vbdate(vB::getDatastore()->getOption('timeformat'), $raffle['stopdate']) . ' ' . $vbphrase['on'] . ' ' . vbdate(vB::getDatastore()->getOption('dateformat'), $raffle['stopdate']);

			$stored_raffles["$raffle[id]"] = $raffle;
		}
		return $stored_raffles;
	}

	public static function getOldRaffles()
	{
		$mytime = time();
		$getraffle = vB::getDbAssertor()->assertQuery('raffles5:getRafflesOld',array('mytime' => $mytime));
		$phrases = array("raffle_active", "raffle_drawn", "raffle_waiting");
		$vbphrase = vB_Api::instanceInternal('phrase')->fetch($phrases);
		$maxlength = vB::getDatastore()->getOption('raffle_preview_max');

		foreach ($getraffle AS $raffle)
		{
			if(strlen($raffle['description']) > $maxlength)
			{
				if(strpos($raffle['description'],"[list]") && strpos($raffle['description'],"[list]") < $maxlength)
				{
					$raffle['description'] = substr($raffle['description'], 0, $maxlength) . '...[/list]';
				}else{
					$raffle['description'] = substr($raffle['description'], 0, $maxlength) . '...<br /><br />';
				}
			}else{
				$raffle['description'] = substr($raffle['description'], 0, $maxlength) . '...<br /><br />';
			}

			if(empty($raffle['prizeimg'])) $raffle['prizeimg'] = 'core/pakages/raffles5/images/default.gif';
			$picturesize = getimagesize($raffle['prizeimg']); 

			if($picturesize[0] > $picturesize[1])
			{ 
				$percentage = (vB::getDatastore()->getOption('raffle_maxpicsize') / $picturesize[0]); 
			}else{ 
				$percentage = (vB::getDatastore()->getOption('raffle_maxpicsize') / $picturesize[1]); 
			} 

			$raffle['picture_width'] = round($picturesize[0] * $percentage); 
			$raffle['picture_height'] = round($picturesize[1] * $percentage); 

			if($raffle['enddate'] <= $mytime && $raffle['winner'] == "")
			{
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_wait_color') . "'><b>" . $vbphrase['raffle_waiting'] . "</b></font>";
			}elseif($raffle['winner'] != ""){
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_drawn_color') . "'><b>" . $vbphrase['raffle_drawn'] . "</b></font>";
			}else{
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_active_color') . "'><b>" . $vbphrase['raffle_active'] . "</b></font>";
			}
			
			$raffle['enddate'] = vbdate(vB::getDatastore()->getOption('dateformat'), $raffle['enddate']);
			$raffle['oneless'] = vbdate(vB::getDatastore()->getOption('timeformat'), $raffle['stopdate']) . ' ' . $vbphrase['on'] . ' ' . vbdate(vB::getDatastore()->getOption('dateformat'), $raffle['stopdate']);
			$stored_raffles["$raffle[id]"] = $raffle;
		}
		return $stored_raffles;
	}

	public static function getRaffleDetails()
	{
		$passed_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
			'do' => vB_Cleaner::TYPE_STR
		));
		$action = $passed_vars['do'];
		$mytime = time();

		if($action <> 'register')
		{
			$second_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
				'id' => vB_Cleaner::TYPE_INT,
				'e' => vB_Cleaner::TYPE_INT
			));
			$id = $second_vars['id'];
			$error = intval($second_vars['e']);
			$userInfo = vB_User::fetchUserinfo();
			require_once(DIR . '/includes/class_bbcode.php');
			$registry = vB::get_registry();

			if (empty($registry->db) AND !empty(vB::$db))
			{
				$registry->db = vB::$db;
			}
			$parser = new vB_BbCodeParser($registry, fetch_tag_list());
			$raffle = vB::getDbAssertor()->getRow('raffle',array('id' => intval($id)));
			$raffle['permission'] = true;
			if($error)	$raffle['error'] = $error;

			// Get the phrases we may need to use
			$phrases = array("at",
						"on",
						"raffle_active", 
						"raffle_closed", 
						"raffle_drawn", 
						"raffle_ended",
						"raffle_waiting", 
						"raffle_bad_group", 
						"raffle_entry_limit", 
						"raffle_low_posts", 
						"raffle_missing_address", 
						"raffle_missing_phone", 
						"raffle_missing_paypal", 
						"raffle_recent", 
						"day", 
						"days", 
						"raffle_hour",
						"raffle_hours",
						"raffle_minute", 
						"raffle_minutes", 
						"raffle_second", 
						"raffle_seconds");
			$vbphrase = vB_Api::instanceInternal('phrase')->fetch($phrases);

			// Set picture size depending on where it's displayed
			if(empty($raffle['prizeimg'])) $raffle['prizeimg'] = 'core/packages/raffles5/images/default.gif';
			$picturesize = getimagesize($raffle['prizeimg']); 

			if($picturesize[0] > $picturesize[1])
			{ 
				$percentage = (vB::getDatastore()->getOption('raffle_detail_width') / $picturesize[0]); 
			}else{ 
				$percentage = (vB::getDatastore()->getOption('raffle_detail_width') / $picturesize[1]); 
			} 

			$raffle['picture_width'] = round($picturesize[0] * $percentage); 
			$raffle['picture_height'] = round($picturesize[1] * $percentage); 

			// Filter users that can't enter the raffle
			if(!is_member_of($userInfo, explode(',', $raffle['groupperm'])) || is_member_of($userInfo, explode(',', $raffle['nogroup']))) $raffle['msg'] = $vbphrase['raffle_bad_group'];
			if(intval($raffle['reqpost']) && ($userInfo['posts'] < intval($raffle['reqpost'])) && !$raffle['msg']) $raffle['msg'] = $vbphrase['raffle_low_posts'];

			// Set the status display for the raffle
			if($raffle['stopdate'] <= $mytime && $raffle['winner'] == "")
			{
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_wait_color') . "'><b>" . $vbphrase['raffle_waiting'] . "</b></font>";
				$raffle['msg'] = $vbphrase['raffle_closed'];
			}elseif($raffle['winner'] != ""){
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_drawn_color') . "'><b>" . $vbphrase['raffle_drawn'] . "</b></font>";
				$raffle['msg'] = $vbphrase['raffle_ended'];
			}else{
				$raffle['status'] = "<font color='". vB::getDatastore()->getOption('raffle_active_color') . "'><b>" . $vbphrase['raffle_active'] . "</b></font>";
			}

			if(!$raffle['msg'])
			{
				// Check user profile fields
				if(vB::getDatastore()->getOption('raffle_require_address') && empty($userInfo[trim(vB::getDatastore()->getOption('raffle_addyfield'))])) $raffle['msg'] .= $vbphrase['raffle_missing_address'];
				if(vB::getDatastore()->getOption('raffle_require_phone') && empty($userInfo[trim(vB::getDatastore()->getOption('raffle_phonefield'))])) $raffle['msg'] .= $vbphrase['raffle_missing_phone'];
				if(vB::getDatastore()->getOption('raffle_require_paypal') && empty($userInfo[trim(vB::getDatastore()->getOption('raffle_paypalfield'))])) $raffle['msg'] .= $vbphrase['raffle_missing_paypal'];

				// Check number of entries by user if entry delay is set
				if($raffle['entrydelay'] > 0 && $raffle['numentries'] > 1 && !$raffle['msg'])
				{
					// Set delay for entry info phrase
					$day_text = ' ' . $vbphrase['day'];
					$hour_text = ' ' . $vbphrase['raffle_hour'];
					$minute_text = ' ' . $vbphrase['raffle_minute'];
					$second_text =  ' ' . $vbphrase['raffle_second'];
					$wait = $raffle['entrydelay'];
					$days = intval(floor($wait / 86400)); 
					if($days > 1) $day_text = ' ' . $vbphrase['days'];
					$wait = $wait % 86400; 
					$hours = intval(floor($wait / 3600)); 
					$wait = $wait % 3600; 
					$minutes = intval(floor($wait / 60)); 
					if($minutes > 1) $minute_text = ' ' . $vbphrase['raffle_minutes'];
					$seconds = $wait % 60; 
					if($seconds > 1) $second_text = ' ' . $vbphrase['raffle_seconds'];
					if($minutes == 60){ 
						$hours = $hours+1; 
						$minutes = 0; 
					} 
					if($hours > 1) $hour_text = ' ' . $vbphrase['raffle_hours'];
					$raffle['waittime'] = "";
					if($days > 0) $raffle['waittime'] .= $days . $day_text . " ";
					if($hours > 0) $raffle['waittime'] .= $hours . $hour_text . " ";
					if($minutes > 0) $raffle['waittime'] .= $minutes . $minute_text . " ";
					if($seconds > 0) $raffle['waittime'] .=  $seconds . $second_text;
					$maxback = 0;
					$lastentries = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));
					$raffle['entered'] = vB::getDbAssertor()->affected_rows($lastentries);
					$maxback = $mytime - $raffle['entrydelay'];
					$lastentries = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));
					$entries_in_delay = vB::getDbAssertor()->affected_rows($lastentries);
					if($entries_in_delay >= 1) $entry_causing_delay = vB::getDbAssertor()->getRow('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));

					if($entries_in_delay >= $raffle['maxperiod'])
					{
						$time_length = ($entry_causing_delay['entrydate'] + $raffle['entrydelay']) - $mytime;
						$day_text = ' ' . $vbphrase['day'];
						$hour_text = ' ' . $vbphrase['raffle_hour'];
						$minute_text = ' ' . $vbphrase['raffle_minute'];
						$second_text = ' ' . $vbphrase['raffle_second'];
						$days = intval(floor($time_length / 86400)); 
						if($days > 1) $day_text = ' ' . $vbphrase['days'];
						$time_length = $time_length % 86400; 
						$hours = intval(floor($time_length / 3600)); 
						$time_length = $time_length % 3600; 
						$minutes = intval(floor($time_length / 60)); 
						if($minutes > 1) $minute_text = ' ' . $vbphrase['raffle_minutes'];
						$seconds = $time_length % 60; 
						if($seconds > 1) $second_text = ' ' . $vbphrase['raffle_seconds'];

						if($minutes == 60)
						{ 
							$hours = $hours+1; 
							$minutes = 0; 
						} 

						if($hours > 1) $hour_text =  ' ' . $vbphrase['raffle_hours'];
						if($days > 0) $time_message .= $days . $day_text . " ";
						if($hours > 0) $time_message .= $hours . $hour_text . " ";
						if($minutes > 0) $time_message .= $minutes . $minute_text . " ";
						if($seconds > 0 && $days == 0 && $hours == 0 && $minutes <= 2) $time_message .=  $seconds . $second_text;
						$raffle['msg'] = construct_phrase($vbphrase['raffle_recent'], $time_message) . '<br />';
					}else{
						$maxback = 0;
						$lastentries = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));
						$raffle['entered'] = vB::getDbAssertor()->affected_rows($lastentries);
						if($raffle['entered'] == $raffle['numentries']) $raffle['msg'] = $vbphrase['raffle_entry_limit'];
						$raffle['entriesleft'] = $raffle['maxperiod'] - $entries_in_delay;
					}
				}else{ // Check number of entries by user if no entry delay is set
					$maxback = 0;
					$lastentries = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));
					$raffle['entered'] = vB::getDbAssertor()->affected_rows($lastentries);
					if($raffle['entered'] == $raffle['numentries']) $raffle['msg'] = $vbphrase['raffle_entry_limit'];
					$raffle['entriesleft'] = $raffle['numentries'] - $raffle['entered'];
				}
			}
			$raffle['rawstart'] = $raffle['startdate'];
			$raffle['rawend'] = $raffle['enddate'];
			$raffle['startdate'] = vbdate(vB::getDatastore()->getOption('dateformat'), $raffle['startdate']);
			$raffle['oneless'] = vbdate(vB::getDatastore()->getOption('timeformat'), $raffle['stopdate']) . ' ' . $vbphrase['on'] . ' ' . vbdate(vB::getDatastore()->getOption('dateformat'), $raffle['stopdate']);


			$raffle['enddate'] = vbdate(vB::getDatastore()->getOption('dateformat'), $raffle['rawend']);
			if(vB::getDatastore()->getOption('raffle_showtime')) $raffle['enddate'] .= ' ' . $vbphrase['at'] . ' ' . vbdate(vB::getDatastore()->getOption('timeformat'), $raffle['rawend']);

			$raffle['description'] = $parser->do_parse($raffle['description'], 1, 1, 1, 1, 1, 0,'false');
			$raffle['show'] = true;
			return $raffle;
		}else{
			$userInfo = vB_User::fetchUserinfo();

			if($userInfo['userid'] < 1)
			{
				$raffle['permission'] = false;
				return $raffle;
			}
			$second_vars = vB::getCleaner()->cleanArray($_REQUEST, array(
				'id' => vB_Cleaner::TYPE_INT,
				'agree' => vB_Cleaner::TYPE_INT,
				'startdate' => vB_Cleaner::TYPE_INT,
				'enddate' => vB_Cleaner::TYPE_INT,
				'numentries' => vB_Cleaner::TYPE_INT,
				'usetickets' => vB_Cleaner::TYPE_INT,
				'membertickets' => vB_Cleaner::TYPE_INT,
				'humanverify' => vB_Cleaner::TYPE_ARRAY
			));
			$mytime = time();
			$id = intval($second_vars['id']);
			$enddate = $second_vars['enddate'];
			$current_date = intval(date("Ymd", $mytime));
			$usetickets = intval($second_vars['usetickets']);
			$membertickets = intval($second_vars['membertickets']);
			$raffle = vB::getDbAssertor()->getRow('raffle',array('id' => $id));
			$raffle['permission'] = true;

			// Check if member is allowed to enter this raffle
			if(!is_member_of($userInfo, explode(',', $raffle['groupperm'])) || is_member_of($userInfo, explode(',', $raffle['nogroup']))) $raffle['permission'] = false;
			if(intval($raffle['reqpost']) && ($userInfo['posts'] < intval($raffle['reqpost'])) && !$raffle['msg'])$raffle['permission'] = false;
			if(!$raffle['permission']) return $raffle;

			// Check if member must wait to enter again
			$maxback = $mytime - $raffle['entrydelay'];
			$lastentries = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));
			$entries_in_delay = vB::getDbAssertor()->affected_rows($lastentries);
			if($entries_in_delay >= $raffle['maxperiod']) $raffle['error'] = 1;

			// Check if member has reached the maximum number of entries allowed
			$maxback = 0;
			$lastentries = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUserEntry',array('id' => $id, 'maxback' => $maxback, 'userid' => $userInfo['userid']));
			$raffle['entered'] = vB::getDbAssertor()->affected_rows($lastentries);
			$can_enter_times_left = $raffle['numentries'] - $raffle['entered'];
			if($can_enter_times_left == 0 && !$raffle['error']) $raffle['error'] = 2;

			// Make sure the raffle hasn't ended
			if($current_date >= $raffle['stopdate'] && !$raffle['error']) $raffle['error'] = 3;

			// Check if member agreed to the rules
			if(!$second_vars['agree'] && !$raffle['error']) $raffle['error'] = 4;

			// Check to be sure member is entering at least once
			if($usetickets < 1 && !$raffle['error']) $raffle['error'] = 5;

			// Check to be sure member is not trying to enter more than allowed
			if($usetickets > $raffle['numentries'] && !$raffle['error']) $raffle['error'] = 6;
			if($usetickets > $membertickets && !$raffle['error']) $raffle['error'] = 7;

			// Don't register for raffle - send errors to the widget
			if($raffle['error']) $raffle['redirect'] = $id;
			if($raffle['redirect']) return $raffle;

			$tickets_used = 0;
			$fieldsArray = array('raffleid', 'userid', 'entrydate', 'ipaddress');
			$queryBits[] = array($id, $userInfo['userid'], $mytime, IPADDRESS);

			while ($tickets_used < $usetickets)
			{
				$insertEntry = vB::getDbAssertor()->assertQuery('raffle_entries',
					array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_MULTIPLEINSERT,
						vB_dB_Query::FIELDS_KEY => $fieldsArray,
						vB_Db_Query::VALUES_KEY => $queryBits
					)
				);
				$tickets_used++;
			}

			$raffle['error'] = 8;
			$raffle['redirect'] = $id;
			return $raffle;
		}
	}
}
