<?php if (!defined('VB_ENTRY')) die('Access denied.');

class Raffles5_dB_MYSQL_QueryDefs extends vB_dB_QueryDefs
{
	protected $db_type = 'MYSQL';

	protected static $permission_string = false;

	protected $table_data = array(
		'raffle' => array(
			'key' => array('id','name'), 
				'structure' => array(
					'id', 'name', 'description', 'startdate', 'enddate', 'rules', 'cost', 'reqpost', 'groupperm', 
					'numentries', 'entrydelay', 'maxperiod', 'numprizes', 'prizeimg', 'showimage', 'winner', 
					'multiple', 'nogroup')
		),

		'raffle_entries' => array(
			'key' => array('entryid', 'raffleid'), 
				'structure' => array(
					'entryid', 'raffleid', 'userid', 'entrydate', 'ipaddress')
		)
	); 

	protected $query_data = array(
		'raffle_table_query' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_CREATE,
			'query_string' => "CREATE TABLE IF NOT EXISTS {TABLE_PREFIX}raffle (
				id int(10) NOT NULL auto_increment,
				name varchar(200) NOT NULL default '',
				description text NOT NULL,
				startdate int(10) NOT NULL default '0',
				enddate int(10) NOT NULL default '0',
				drawtime varchar(5) NOT NULL default '',
				stopdate int(10) NOT NULL default '0',
				stoptime varchar(5) NOT NULL default '',
				rules text NOT NULL,
				cost int(10) NOT NULL default '0',
				reqpost int(10) NOT NULL default '0',
				groupperm varchar(250) NOT NULL default '',
				numentries int(10) NOT NULL default '0',
				entrydelay int(10) NOT NULL default '0',
				maxperiod INT(10) NOT NULL DEFAULT '1',
				numprizes int(10) NOT NULL default '0',
				prizeimg varchar(250) NOT NULL default '',
				showimage TINYINT(1) NOT NULL DEFAULT '0',
				winner text NOT NULL,
				multiple TINYINT(1) NOT NULL DEFAULT '0',
				nogroup varchar(250) NOT NULL DEFAULT '',
				PRIMARY KEY (id),
				KEY name (name))"
		),
		'raffle_entries_table_query' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_CREATE,
			'query_string' => "CREATE TABLE IF NOT EXISTS {TABLE_PREFIX}raffle_entries (
				entryid int(10) NOT NULL auto_increment,
				raffleid int(10) NOT NULL default '0',
				userid int(10) NOT NULL default '0',
				entrydate int(10) NOT NULL default '0',
				ipaddress varchar(25) NOT NULL default '',
				PRIMARY KEY (entryid),
				KEY raffleid (raffleid))"
		),
		'raffle_check_user_field' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SHOW COLUMNS FROM {TABLE_PREFIX}user 
				LIKE 'raffletickets'
			"
		),
		'raffle_add_user_field' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_UPDATE,
			'query_string' => "
				ALTER TABLE {TABLE_PREFIX}user ADD raffletickets INT(10) NOT NULL DEFAULT '0'
			"
		),
		'raffle_remove_user_field' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_UPDATE,
			'query_string' => "
				ALTER TABLE {TABLE_PREFIX}user DROP COLUMN raffletickets
			"
		),
		'raffle_table_drop' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_UPDATE,
			'query_string' => "
				DROP TABLE IF EXISTS {TABLE_PREFIX}raffle
			"
		),
		'raffle_entry_table_drop' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_UPDATE,
			'query_string' => "
				DROP TABLE IF EXISTS {TABLE_PREFIX}raffle_entries
			"
		),
		'raffle_drop_stylevar' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_DELETE,
			'query_string' => "
				DELETE FROM {TABLE_PREFIX}stylevar 
				WHERE stylevarid LIKE 'raffle_%'
			"
		),
		'raffle_drop_stylevardfn' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_DELETE,
			'query_string' => "
				DELETE FROM {TABLE_PREFIX}stylevardfn 
				WHERE stylevarid LIKE 'raffle_%'
			"
		),
		'getRaffleEntryWidget' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT p.pagetemplateid, i.widgetinstanceid, w.widgetid
				FROM {TABLE_PREFIX}pagetemplate AS p
				LEFT JOIN {TABLE_PREFIX}widgetinstance AS i ON (i.pagetemplateid = p.pagetemplateid)
				LEFT JOIN {TABLE_PREFIX}widget AS w ON (w.guid = 'raffles5-503e77da32c629.99780520')
				WHERE p.guid = 'raffles5-503e77da32c629.99780701'
			"
		),
		'raffleAddWidgetInstance' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_INSERT,
			'query_string' => "
				INSERT INTO {TABLE_PREFIX}widgetinstance
				(parent, pagetemplateid, widgetid, displaysection, displayorder)
				VALUES ({values})
			"
		),
		'getRafflesShowOld' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT *
				FROM {TABLE_PREFIX}raffle
			"
		),
		'getRafflesNoOld' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT *
				FROM {TABLE_PREFIX}raffle
				WHERE startdate <= {mytime}
				AND winner = ''
			"
		),
		'getRafflesOld' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT *
				FROM {TABLE_PREFIX}raffle
				WHERE startdate <= {mytime}
				AND winner > ''
			"
		),
		'getRaffleDetails' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT *
				FROM {TABLE_PREFIX}raffle
				WHERE id = {id}
			"
		),
		'getRafflesDraw' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT *
				FROM {TABLE_PREFIX}raffle
				WHERE enddate <= {mytime}
				AND winner = ''
			"
		),
		'getRaffleEntries' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT userid, entrydate
				FROM {TABLE_PREFIX}raffle_entries
				WHERE raffleid = '{id}'
				AND userid = '{userid}'
				ORDER BY entrydate DESC
			"
		),
		'getRaffleUserEntry' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT userid, entrydate
				FROM {TABLE_PREFIX}raffle_entries
				WHERE raffleid = '{id}'
				AND userid = '{userid}'
				AND entrydate >= '{maxback}'
				ORDER BY entrydate ASC
			"
		),
		'getRaffleAllEntryCount' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT userid
				FROM {TABLE_PREFIX}raffle_entries
			"
		),
		'getRaffleEntryCount' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT userid
				FROM {TABLE_PREFIX}raffle_entries
				WHERE raffleid = {raffleid}
			"
		),
		'getRaffleEntriesAllbyDate' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid > 0
				ORDER BY raffle_entries.entrydate ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleIDbyDate' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid = {sqlconds}
				ORDER BY raffle_entries.entrydate ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleEntriesAllbyUserid' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid > 0
				ORDER BY raffle_entries.userid ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleIDbyUserid' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid = {sqlconds}
				ORDER BY raffle_entries.userid ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleEntriesAllbyRaffle' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid > '0'
				ORDER BY raffle.name ASC, raffle_entries.entrydate ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleEntriesAllbyRaffleID' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid = {sqlconds}
				ORDER BY raffle.name ASC, raffle_entries.entrydate ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleUserEntries' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid > 0
				ORDER BY user.username ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleIDbyUsername' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT raffle_entries.*, user.username, raffle.name
				FROM {TABLE_PREFIX}raffle_entries AS raffle_entries
				LEFT JOIN {TABLE_PREFIX}user AS user ON (user.userid = raffle_entries.userid)
				LEFT JOIN {TABLE_PREFIX}raffle AS raffle ON (raffle.id = raffle_entries.raffleid)
				WHERE raffle_entries.raffleid = {sqlconds}
				ORDER BY user.username ASC
				LIMIT {startat}, {perpage}"
		),
		'getRaffleUniqueEntries' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT DISTINCT userid
				FROM {TABLE_PREFIX}raffle_entries
				WHERE raffleid = '{id}'
				ORDER BY userid
			"
		),
		'getRaffleWinner' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT, 
			'query_string' => "
				SELECT e.entryid, e.userid, u.username
				FROM {TABLE_PREFIX}raffle_entries AS e
				LEFT JOIN {TABLE_PREFIX}user AS u ON (u.userid = e.userid)
				WHERE e.raffleid = {id} 
				ORDER BY RAND() LIMIT 1"
		),
		'getRaffleNames' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT id, name
				FROM {TABLE_PREFIX}raffle
				ORDER BY name
			"
		), 
		'getUsergroups' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT usergroupid, title
				FROM {TABLE_PREFIX}usergroup
				ORDER BY title
			"
		),
		'getFileTypes' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT extension
				FROM {TABLE_PREFIX}attachmenttype
			"
		),
		'getRaffleImage' => array(
			vB_dB_Query::QUERYTYPE_KEY => vB_dB_Query::QUERY_SELECT,
			'query_string' => "
				SELECT *
				FROM {TABLE_PREFIX}raffle
				WHERE id = {id}
				AND prizeimg = {prizeimg}
			"
		),
	);

	public function fetchSettingsByGroup($params, $db, $check_only = false)
	{
		if ($check_only)
		{
			return true;
		}else{
			$sql = "SELECT setting.*, settinggroup.grouptitle
				FROM " . TABLE_PREFIX . "settinggroup AS settinggroup
				LEFT JOIN " . TABLE_PREFIX . "setting AS setting USING(grouptitle)
				WHERE 1=1";
			if ($params['product'])
			{
				$sql .= "
				    AND settinggroup.product LIKE '" . $params['product'] . "%'
				";
			}
			if (!$params['debug'])
			{
				$sql .= "
				    AND settinggroup.displayorder <> 0
				";
			}
			$sql .= "ORDER BY settinggroup.displayorder, setting.displayorder";
			return $this->_wrapper($sql, $db, $check_only);
		}
	}

	public function _wrapper($sql, vB_Database $db, $check_only = false)
	{
		$resultclass = 'vB_dB_' . $this->db_type . '_result';
		$config = vB::get_config();
		if (isset($config['Misc']['debug_sql']) AND $config['Misc']['debug_sql']) echo "sql: $sql<br />\n";
		$result = new $resultclass($db, $sql);
		return $result;
	}
}