<?php
if (!defined('VB_ENTRY')) die('Access denied.');

abstract class Raffles5_Library_Content extends vB_Library
{
	public function add($data, array $options = array())
	{
		if (empty($data['parentid'])) throw new vB_Exception_Api('need_parent_node');
		$tablename = array('text', 'privatemessage');
		$pmcontenttypeid = vB_Types::instance()->getContentTypeId('vBForum_PrivateMessage');
		$nodeFields = vB_Library::instance('node')->getNodeFields();
		$assertor = vB::getDbAssertor();
		$userid = $data['userid'];
		if (empty($data['authorname'])) $data['authorname'] = vB_Api::instanceInternal('user')->fetchUserName($userid);
		$nodeids = array($data['parentid']);
		$cache = vB_Cache::instance(vB_Cache::CACHE_FAST);
		$found = array();
		$notfound = array();

		foreach ($nodeids AS $nodeid)
		{
			if (!intval($nodeid)) throw new vB_Exception_Api('invalid_data');
			$hashKey = 'node_' . $nodeid . "_lvl3data";
			$adata = $cache->read($hashKey);

			if (!empty($adata))
			{
				$found[$nodeid] = $adata;
				break;
			}
			$notfound[] = $nodeid;
		}

		$parentInfo = array('found' => $found, 'notfound' => $notfound);

		if ($parentInfo AND $parentInfo['found'] AND $parentInfo['found'][$data['parentid']])
		{
			$parentInfo = $parentInfo['found'][$data['parentid']];
		}else{
			$parentInfo = vB_Library::instance('node')->getNodeContent($data['parentid']);
			$parentInfo = $parentInfo[$data['parentid']];
		}

		$data['protected'] = $parentInfo['protected'];
		$data['hasowner'] = $parentInfo['hasowner'];
		$channelContentTypeId = vB_Types::instance()->getContentTypeId('vBForum_PrivateMessage');
		if (!empty($data['prefixid'])) unset($data['prefixid']);
		if (!empty($data['iconid'])) unset($data['iconid']);
		$data['lastupdate'] =  vB::getRequest()->getTimeNow();
		if (empty($data['created'])) $data['created'] =  vB::getRequest()->getTimeNow();
		if (!isset($data['publishdate'])) $data['publishdate'] = vB::getRequest()->getTimeNow();
		$nodevals = array();
		$nodevals['showpublished'] = 0;
		$nodevals['inlist'] = 1;
		if (empty($data['htmltitle']) AND !empty($data['title'])) $data['htmltitle'] = vB_String::htmlSpecialCharsUni($data['title']);
		$parentid = $data['parentid'];

		foreach ($data as $field => $value)
		{
			if (in_array($field, $nodeFields)) $nodevals[$field] = $value;
		}

		if (empty($nodevals)) throw new vB_Exception_Api('invalid_data');
		$nodevals['userid'] = $data['userid'];
		$nodevals['contenttypeid'] = $pmcontenttypeid;
		$nodevals[vB_dB_Query::TYPE_KEY] = vB_dB_Query::QUERY_INSERT;
		$nodeid = $assertor->assertQuery('vBForum:node', $nodevals);
		if (!$nodeid) throw new vB_Exception_Api('invalid_data');
		if (is_array($nodeid)) $nodeid = $nodeid[0];
		$assertor->assertQuery('vBForum:node', array(vB_dB_Query::TYPE_KEY=> vB_dB_Query::QUERY_UPDATE, 'nodeid' => $nodeid, 'lastcontent' =>  vB::getRequest()->getTimeNow(), 'lastcontentid' => $nodeid));
		$cacheEvents = array("fUserContentChg_" . $nodevals['userid']);

		//Update the node table with the 'starter' just in case task runs when nobody is logged in.
		$update = array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_UPDATE, 'starter' => $nodeid, 'nodeid' => $nodeid);
		$assertor->assertQuery('vBForum:node', $update);
		$cacheEvents[] = "nodeChg_" . $parentid;

		vB_Cache::instance()->event($cacheEvents);
		vB_Cache::instance(vB_Cache::CACHE_FAST)->event($cacheEvents);
		$assertor->assertQuery('vBForum:closure', array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_INSERT, 'parent' => $nodeid, 'child' => $nodeid,'depth' => 0, 'publishdate' => $nodevals['publishdate']));
		$assertor->assertQuery('vBForum:addClosure', array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_STORED, 'nodeid' => $nodeid));
		$index = empty($data['noIndex']);
		unset($data['noIndex']);
		$tables = $tablename;

		foreach ($tables as $table)
		{
			$structure = $assertor->fetchTableStructure('vBForum:' . $table);
			$queryData = array();
			$queryData[vB_dB_Query::TYPE_KEY] = vB_dB_Query::QUERY_INSERT;
			$queryData['nodeid'] = $nodeid;
			foreach ($structure['structure'] as $fieldname)
			{
				if (isset($data[$fieldname])) $queryData[$fieldname] = $data[$fieldname];
			}
			$assertor->assertQuery('vBForum:' . $table, $queryData);
		}

		if($index) vB_Api::instance('Search')->index($nodeid);
		vB_Api::instance('Search')->purgeCacheForCurrentUser($data['userid']);
		vB_Cache::instance(vB_Cache::CACHE_FAST)->event("fContentChg_$parentid");
		vB_Cache::instance()->event("fContentChg_$parentid");

		if (!empty($notifications) AND empty($options['skipNotifications']))
		{
			$messageLibrary = Raffles5_Library_Content_Privatemessage;
			foreach ($notifications as $notification)
			{
				$data = array('msgtype' => 'notification', 'about' => $notification['about'],
				'rawtext' => '',
				'aboutid' => $notification['aboutid'],
				'sentto' => $notification['userid']);
				$nodeid = $messageLibrary->add($data);
			}
		}

		vB_Library::instance('node')->clearCacheEvents($parentid);
		return $nodeid;
	}
}