<?php
if (!defined('VB_ENTRY')) die('Access denied.');

class Raffles5_Library_Content_Privatemessage extends vB_Library_Content_Text
{
	CONST TRASH_FOLDER = 'trash';
	CONST REQUEST_FOLDER = 'requests';
	CONST MESSAGE_FOLDER = 'messages';
	CONST NOTIFICATION_FOLDER = 'your_notifications';
	CONST PENDING_FOLDER = 'pending_posts';
	CONST SENT_FOLDER = 'sent_items';

	public function add($data, array $options = array())
	{
		$sender = intval($data['userid']);
		$pmChannel = self::fetchPMChannel();
		$assertor = vB::getDbAssertor();

		if (isset($data['msgRecipients']) AND empty($data['sentto']))
		{
			$recipientNames = explode(',', $data['msgRecipients']);
			$recipQry = $assertor->getRows('fetchPmRecipients', array('usernames' => $recipientNames, 'userid' => $sender));
			$bf_misc_useroptions = vB::getDatastore()->getOption('bf_misc_useroptions');
			if (!$recipQry OR !empty($recipQry['errors'])) throw new vB_Exception_Api('invalid_pm_recipients');
			foreach ($recipQry as $recipient)
			{
				$recipientcontext = vB::getUserContext($recipient['userid']);
				$recipientsettings = vB_Api::instanceInternal('user')->fetchUserSettings($recipient['userid']);
				$data['sentto'][] = $recipient['userid'];
			}
		}

		if (!isset($data['msgtype']) OR $data['msgtype'] <> 'notification')
		{
			$data['msgtype'] = 'message';
		}else if (($data['msgtype'] == 'notification')){
			if (empty($data['about']) OR empty($data['aboutid']) OR empty($data['sentto'])) throw new vB_Exception_Api('invalid_data');

			$existing = $assertor->getRow('vBForum:fetchNotification',
									array(vB_dB_QUERY::TYPE_KEY => vB_dB_QUERY::QUERY_STORED, 'userid' => $data['sentto'],
									'about' => $data['about'], 'aboutid' => $data['aboutid']));

			if ($existing AND !empty($existing ) AND empty($existing['errors']))
			{
				$assertor->assertQuery('vBForum:sentto', array(vB_dB_QUERY::TYPE_KEY => vB_dB_QUERY::QUERY_UPDATE,
									vB_dB_QUERY::CONDITIONS_KEY => array('userid' => $data['sentto'], 'nodeid' => $existing['nodeid']),
									'deleted' => 0,	'msgread' => 0));
				return;
			}

			if (empty($data['title'])) $data['title'] = 'notification';
		}

		if (($data['msgtype'] == 'message') AND (empty($data['rawtext']) AND empty($data['pagetext']))) throw new vB_Exception_Api('need_privatemessage_text');
		$senderfolders = self::checkFolders($sender);
		$sendto = array();
		$data['parentid'] = $pmChannel;
		if (empty($data['sentto'])) throw new vB_Exception_Api('invalid_data');

		if (!is_array($data['sentto']))
		{
			$sendto = array($data['sentto']);
		}else{
			$sendto = array_unique($data['sentto']);
		}

		$data['userid'] = $sender;
		$fields = array('parentid', 'rawtext', 'pagetext', 'msgtype', 'title', 'userid', 'about', 'aboutid', 'folderid', 'deleted', 'msgread', 'publishdate', 'url', 'filedataid', 'url_title', 'url_meta', 'url_image');
		$contentData = array();

		foreach ($fields as $field)
		{
			if (isset($data[$field])) $contentData[$field] = $data[$field];
		}

		$nodeid = Raffles5_Library_Content::add($contentData, $options);
		if (!$nodeid OR !empty($nodeid['errors']) OR !intval($nodeid)) throw new vB_Exception_Api('invalid_data');

		if ($data['msgtype']== 'notification')
		{
			$folderKey = self::NOTIFICATION_FOLDER;
			$insertSent = false;
		}else{
			$folderKey = self::MESSAGE_FOLDER;
			$insertSent = true;
		}

		foreach ($sendto as $recipient)
		{
			$repfolders = self::checkFolders($recipient);
			$sendData = array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_INSERT, 'userid' => $recipient, 'nodeid' => $nodeid, 'folderid' => $repfolders[$recipient]['systemfolders'][$folderKey]);
			$assertor->assertQuery('vBForum:sentto', $sendData);
		}

		if (isset($data['respondto']) AND $data['respondto'] AND !$senderIncluded)
		{
			$sendfolders = self::checkFolders($msgSender);
			$sendData = array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_INSERT, 'userid' => $msgSender, 'nodeid' => $data['respondto'], 'folderid' => $sendfolders[$msgSender]['systemfolders'][$folderKey], 'msgread' => 1);
			$assertor->assertQuery('vBForum:sentto', $sendData);
		}

		$existing = vB_Library::instance('node')->getNode($data['parentid']);
		$data = array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_UPDATE,
					vB_dB_Query::CONDITIONS_KEY =>array(array('field' => 'nodeid', 'value' => $existing['starter']),
					array('field' => 'userid', 'value' => $sender, 'operator' => vB_dB_Query::OPERATOR_NE)),
					'msgread' => 0, 'deleted' => 0);
		$assertor->assertQuery('vBForum:sentto', $data);
		self::setRead($nodeid, 1, $sender);

		if ($insertSent)
		{
			$data = array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_INSERT, 'userid' => $sender,'nodeid' => $nodeid, 'folderid' => $senderfolders[$sender]['systemfolders'][self::SENT_FOLDER], 'msgread' => 1);
			$assertor->assertQuery('vBForum:sentto', $data);
		}
		vB_Api::instance('Search')->index($nodeid);
		return $nodeid;
	}

	public function checkFolders($userid)
	{
		if (!intval($userid)) throw new vB_Exception_Api('not_logged_no_permission');
		if (!empty($afolders[$userid])) return;
		$userCheck = vB::getDbAssertor()->getRows('user', array('userid' => $userid));
		if (empty($userCheck) OR !empty($userCheck['errors'])) throw new vB_Exception_Api('invalid_data');
		$folderResult = vB::getDbAssertor()->getRows('vBForum:messagefolder', array('userid' => $userid), 'title');
		$systemFolders = array(self::TRASH_FOLDER, self::MESSAGE_FOLDER, self::SENT_FOLDER, self::NOTIFICATION_FOLDER, self::REQUEST_FOLDER, self::PENDING_FOLDER);
		$systemFolderIds = array();
		$folders = array();

		foreach ($folderResult as $folder)
		{
			if (!empty($folder['titlephrase']))
			{
				$folders[$folder['folderid']] = (string) new vB_Phrase('global', $folder['titlephrase']);
				$systemFolderIds[$folder['titlephrase']] = $folder['folderid'];
				$systemKey = array_search($folder['titlephrase'], $systemFolders);
				if ($systemKey !== false) unset($systemFolders[$systemKey]);
			}else{
				$folders[$folder['folderid']] = $folder['title'];
			}
		}

		foreach ($systemFolders as $folderNeeded)
		{
			$adata = array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_INSERT, 'userid' => $userid, 'title' => '', 'titlephrase' => $folderNeeded);
			$folderid = vB::getDbAssertor()->assertQuery('vBForum:messagefolder', $adata);
			$systemFolderIds[$folderNeeded] = $folderid;
			$folders[$folderid] = (string) new vB_Phrase('global', $folderNeeded);
		}

		$afolders[$userid] = array('folders' => $folders, 'systemfolders' => $systemFolderIds);
		return $afolders;
	}

	public function setRead($nodeid, $read, $userid)
	{
		if (is_string($nodeid) AND strpos($nodeid, ',')) $nodeid = explode(',', $nodeid);
		$node = vB::getDbAssertor()->getRow('vBForum:sentto', array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_SELECT, 'nodeid' => $nodeid, 'userid' => $userid));
		if (empty($node) OR !empty($node['errors'])) return;
		vB::getDbAssertor()->assertQuery('vBForum:sentto', array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_UPDATE,
			vB_dB_Query::CONDITIONS_KEY => array(array('field' => 'nodeid', 'value' => $nodeid), array('field' => 'userid', 'value' => $userid)),
			'msgread' => $read));
	}

	public function fetchPMChannel()
	{
		if ($PMChannel) return $PMChannel;
		$PMChannel = vB::getDbAssertor()->getRow('channel', array(vB_dB_Query::TYPE_KEY => vB_dB_Query::QUERY_SELECT, 'guid' => vB_Channel::PRIVATEMESSAGE_CHANNEL));
		$PMChannel = $PMChannel['nodeid'];
		return $PMChannel;
	}
}