<?php
/*
|| Raffles 5
|| Created by Snog (NHawk on vBulletin.org)
*/

error_reporting(E_ALL & ~E_NOTICE);
require_once(DIR . '/includes/functions_misc.php');
$mytime = time();
$phrases = array("raffle_log_start", 
		"raffle_draw_error", 
		"raffle_noentries", 
		"raffle_ticketnumber", 
		"raffle_message_subject",
		"raffle_message_salute",
		"raffle_message_body",
		"raffle_message_close",
		"raffle_admin_title",
		"raffle_autodrawn"
);
$vbphrase = vB_Api::instanceInternal('phrase')->fetch($phrases);
log_cron_action($vbphrase['raffle_log_start'] . ' Draw Code v5.0.4 Lite',$nextitem, 0);
if(vB::getDatastore()->getOption('raffle_debug'))
{
$draw_data = vB::getDbAssertor()->getRow('cron',array('product' => 'raffles5'));
$draw_data['minute'] = unserialize($draw_data['minute']);
$run_minute = $draw_data['minute'][0];
if($run_minute < 10) $run_minute = '0' . $run_minute;

	if($draw_data['hour'] == -1)
	{
		$drawtext = '*';
	}else{
		$drawtext = $draw_data['hour'];
	}
	if($draw_data['minute'][0] < 0)
	{
		$runmintext = ' : *';
	}else{
		$runmintext = ' : ' . $draw_data['minute'][0];
	}
	$X = 1;
	While($X < 6)
	{
		if($draw_data['minute'][$X] == '')
		{
			$runmintext .= ',-';
		}else{
			$runmintext .= ',' . $draw_data['minute'][$X];
		}
		$X++;
	}
	log_cron_action('Cron Run Schedule = ' . $drawtext . $runmintext,$nextitem, 0);
}
$sender = vB_User::fetchUserinfo(vB::getDatastore()->getOption('raffle_adminid'));

$getraffle = vB::getDbAssertor()->assertQuery('raffles5:getRafflesDraw',array('mytime' => $mytime));

$raffle_count = vB::getDbAssertor()->affected_rows($getraffle);

if(!$raffle_count) log_cron_action('No raffles to draw at this time.',$nextitem, 0);

foreach($getraffle as $raffle)
{
	$winner_count = 0;
	$winner_ids = '';
	$winner_list = '';
	if(vB::getDatastore()->getOption('raffle_debug') && !$raffle['winner'])
	{
		$debug_time = time();
		log_cron_action('Multiple Winners = ' . $raffle['multiple'],$nextitem, 0);
		log_cron_action('Drawing ' . $raffle['name'],$nextitem, 0);
		log_cron_action('Draw Date/Time = ' . vbdate(vB::getDatastore()->getOption('dateformat'), $debug_time) . ' ' . vbdate(vB::getDatastore()->getOption('timeformat'), $debug_time),$nextitem, 0);
	}
	if ($raffle['enddate'] <= $mytime && $raffle['winner'] == "")
	{
		$drawdate = vbdate(vB::getDatastore()->getOption('dateformat'), $mytime);
		if(!$raffle['multiple'])
		{
			$entrycount = vB::getDbAssertor()->assertQuery('raffles5:getRaffleUniqueEntries',array('id' => $raffle['id']));
			$number_entered = vB::getDbAssertor()->affected_rows($entrycount);

			if($number_entered < $raffle['numprizes'])
			{
				$errmsg = construct_phrase($vbphrase['raffle_draw_error'], $raffle['name'], $number_entered, $raffle['numprizes']);
				$subject = $errmsg;
				$message = $errmsg . "\n\r\n\r";

				$data = array(
					'msgRecipients'=>$sender[username],
					'title'=>$subject,
					'userid'=>$sender['userid'],
					'rawtext'=>$message
				);

				$pm = Raffles5_Library_Content_Privatemessage::add($data);

				if($number_entered == 0 && $raffle['numprizes'] >= 1)
				{
					$winner_info = $vbphrase['raffle_noentries'];
					vB::getDbAssertor()->update('raffle', array(
							'winner' => $winner_info 
							),
							array('id' => $raffle['id'])
					); 
				}
				log_cron_action($errmsg,$nextitem, 0);
				$winner_count = $raffle['numprizes'];
			}
		}
		while($winner_count < $raffle['numprizes'])
		{
			$rid = $raffle['id'];
			$winner = vB::getDbAssertor()->getRow('raffles5:getRaffleWinner',array('id' => $rid));

			if(vB::getDatastore()->getOption('raffle_debug')) log_cron_action('Conditional Winner: ' . $winner['userid'],$nextitem, 0);

			if(!$raffle['multiple'] && $winner_list)
			{
				if(vB::getDatastore()->getOption('raffle_debug')) log_cron_action('In Duplicate Check: ' . $winner['userid'],$nextitem, 0);
				while(in_array($winner['userid'], explode(",",$winner_ids)))
				{
					$winner = vB::getDbAssertor()->getRow('raffles5:getRaffleWinner',array('id' => $rid));
				}
				if(vB::getDatastore()->getOption('raffle_debug')) log_cron_action('Finalized Winner: ' . $winner['userid'],$nextitem, 0);
			}
			if(!$winner['userid'])
			{
				$errmsg = construct_phrase($vbphrase['raffle_draw_error'], $raffle['name'], '0', $raffle['numprizes']);
				$subject = $errmsg;
				$message = $errmsg . "\n\r\n\r";

				$data = array(
					'msgRecipients'=>$winner[username],
					'title'=>$subject,
					'rawtext'=>$message
				);

				$pm = Raffles5_Library_Content_Privatemessage::add($data);

				$winner_info = $vbphrase['raffle_noentries'];
				vB::getDbAssertor()->update('raffle', array(
						'winner' => $winner_info 
						),
						array('id' => $raffle['id'])
				); 

				break;


			}else{
				$winner_count = $winner_count + 1;
			}
			if($raffle['numprizes'] == 1 && $winner['userid'])
			{	
				if(!vB::getDatastore()->getOption('raffle_display_tickets'))
				{
					$winner_info = $winner['username'];
				}else{
					$winner_info = $winner['username'] . " (" . $vbphrase['raffle_ticketnumber'] . $winner['entryid'] . ")";
				}


				vB::getDbAssertor()->update('raffle', array(
						'winner' => $winner_info 
						),
						array('id' => $raffle['id'])
				); 

				if(vB::getDatastore()->getOption('raffle_debug')) log_cron_action('Single Prize Winner Recorded: ' . $winner['userid'],$nextitem, 0);

				$subject = $vbphrase['raffle_message_subject'];
				$message = construct_phrase($vbphrase['raffle_message_salute'], $winner[username]) . "\n\r\n\r";
				$message .= construct_phrase($vbphrase['raffle_message_body'], $raffle['name'], $drawdate) . "\n\r\n\r";;
				$message .= construct_phrase($vbphrase['raffle_message_close'], $sender['username'], $vbphrase['raffle_admin_title']);
				if(vB::getDatastore()->getOption('raffle_debug')) log_cron_action('Sending PM To: ' . $winner['userid'],$nextitem, 0);

				$data = array(
					'msgRecipients'=>$winner[username],
					'title'=>$subject,
					'userid'=>$sender['userid'],
					'rawtext'=>$message
				);

				$pm = Raffles5_Library_Content_Privatemessage::add($data);

				$winner_list = $winner_info;
				$drawnmsg = construct_phrase($vbphrase['raffle_autodrawn'], $raffle['name'], $winner_info);
				log_cron_action($drawnmsg,$nextitem, 0);
			}else{
				if($winner['userid'])
				{
					if(!vB::getDatastore()->getOption('raffle_display_tickets'))
					{
						$winner_info = $winner['username'];
					}else	{
						$winner_info = $winner['username'] . " (" . $vbphrase['raffle_ticketnumber'] . $winner['entryid'] . ")";
					}
					if($winner_list)
					{
						$winner_list .= ", " . $winner_info;
						$winner_ids .= "," . $winner['userid'];
					}else{
						$winner_list = $winner_info;
						$winner_ids .= $winner['userid'];
					}
					if(vB::getDatastore()->getOption('raffle_debug'))
					{
						log_cron_action('Current Winner List: ' . $winner_list,$nextitem, 0);
						log_cron_action('Current Winner IDs: ' . $winner_ids,$nextitem, 0);
					}

					if($winner_count == $raffle['numprizes'])
					{
						vB::getDbAssertor()->update('raffle', array(
								'winner' => $winner_list 
								),
								array('id' => $raffle['id'])
						); 

						if(vB::getDatastore()->getOption('raffle_debug')) log_cron_action('Winners Recorded in DB: ' . $winner_list,$nextitem, 0);
					}
					$subject = $vbphrase['raffle_message_subject'];
					$message = construct_phrase($vbphrase['raffle_message_salute'], $winner[username]) . "\n\r\n\r";
					$message .= construct_phrase($vbphrase['raffle_message_body'], $raffle['name'], $drawdate) . "\n\r\n\r";;
					$message .= construct_phrase($vbphrase['raffle_message_close'], $sender['username'], $vbphrase['raffle_admin_title']);

					$data = array(
						'msgRecipients'=>$winner[username],
						'title'=>$subject,
						'userid'=>$sender['userid'],
						'rawtext'=>$message
					);

					$pm = Raffles5_Library_Content_Privatemessage::add($data);

					if(!vB::getDatastore()->getOption('raffle_debug'))
					{
						$drawnmsg = construct_phrase($vbphrase['raffle_autodrawn'], $raffle['name'], $winner_info);
						log_cron_action($drawnmsg,$nextitem, 0);
					}
				}
			}
		}
	}else{
		if(vB::getDatastore()->getOption('raffle_debug') && !$raffle['winner']) log_cron_action('Skipped ' . $raffle['name'] .' not time to draw yet.',$nextitem, 0);
	}
}
log_cron_action('',$nextitem, 1);
?>
